Debian Bug report logs - #670241
linux-2.6: Backporting the qmi_wwan driver to the Debian 3.2/wheezy kernels

version graph

Package: linux-2.6; Maintainer for linux-2.6 is Debian Kernel Team <debian-kernel@lists.debian.org>;

Reported by: Bjørn Mork <bjorn@mork.no>

Date: Tue, 24 Apr 2012 11:12:45 UTC

Severity: important

Tags: patch

Found in version 3.2.15-1

Done: Ben Hutchings <ben@decadent.org.uk>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Tue, 24 Apr 2012 11:12:48 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bjørn Mork <bjorn@mork.no>:
New Bug report received and forwarded. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 24 Apr 2012 11:13:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Bjørn Mork <bjorn@mork.no>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: linux-2.6: Backporting the qmi_wwan driver to the Debian 3.2/wheezy kernels
Date: Tue, 24 Apr 2012 13:10:08 +0200
Package: linux-2.6
Version: 3.2.15-1
Severity: wishlist
Tags: patch

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1


Please add the qmi_wwan driver from current (v3.4-rc)
mainline to the Debian linux-3.2 based kernels. This
is as simple as cherry-picking the commits listed below in
the listed order.  I've verified that the list applies
cleanly on top of v3.2.16 and that it produces the expected
result.

CONFIG_USB_NET_QMI_WWAN must of course be enabled after
adding the driver.  No other CONFIG changes are necessary.


The first batch updates the existing cdc-wdm driver to the
version in v3.4-rc4, except for the module_usb_driver()
changes from commit 65db43054.  That commit touches a large
number of unrelated drivers, and all listed commits apply
cleanly without it, so I believe it's best ignored. The
other changes are necessary to add the subdriver interface
used by the qmi_wwan driver.

The second batch is just a single bugfix for the sierra
driver, which is necessary to allow the qmi_wwan driver
to support some Sierra Wireless devices.  This could have
gone to stable/linux-3.2.y but I did't submit it there as
it is mostly irrelevant without the qmi_wwan driver.

The third batch adds the new qmi_wwan driver as it will appear
in v3.4-rc5.  The driver has been stabilizing for a while,
and I don't expect any major changes to it in the near future.

Thanks for considering this.  Let me know if there are any
problems with this request.



1) add subdriver support to cdc-wdm

19b85b3 USB: cdc-wdm: no need to fill the in request URB every time it's submitted
8143a89 USB: cdc-wdm: kill the now unnecessary bMaxPacketSize0 field and udev variable
820c629 USB: cdc-wdm: avoid printing odd-looking "cdc-wdm-176" names
fec67b4 usb: cdc-wdm: Add device-id for Huawei 3G/LTE modems
8804420 usb: cdc-wdm: make reset work with blocking IO
8457d99 USB: cdc-wdm: no need to use usb_alloc_coherent
0dffb48 usb: cdc-wdm: split out reusable parts of probe
b0c1386 usb: cdc-wdm: adding list lookup indirection
3cc3615 usb: cdc-wdm: adding usb_cdc_wdm_register subdriver support


2) prevent sierra from binding to QMI/wwan interfaces

749541d USB: sierra: avoid QMI/wwan interface on MC77xx


3) add qmi_wwan driver

423ce8c net: usb: qmi_wwan: New driver for Huawei QMI based WWAN devices
c3ecb08 net: qmi_wwan: support devices having a shared QMI/wwan interface
b086cf0 net: qmi_wwan: add Gobi and Pantech UML290 device IDs
11207b6 net: qmi_wwan: add support for ZTE MF820D
1aa35a2 USB: qmi_wwan: Add ZTE (Vodafone) K3565-Z and K4505-Z net interfaces
dbb6d09 USB: qmi_wwan: Add ZTE (Vodafone) K3570-Z and K3571-Z net interfaces
3bc17d1 net: qmi_wwan: support Sierra Wireless MC77xx devices in QMI mode



Bjørn

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAk+Wig0ACgkQ10rqkowbIskgBQCdF9SobH3sjMjNPNjgc19OW6iD
fusAn2aPg1yICRWvKCjrc5ZIGlCQjKOV
=aDUe
-----END PGP SIGNATURE-----




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Wed, 25 Apr 2012 07:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bjørn Mork <bjorn@mork.no>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Wed, 25 Apr 2012 07:57:03 GMT) Full text and rfc822 format available.

Message #10 received at 670241@bugs.debian.org (full text, mbox):

From: Bjørn Mork <bjorn@mork.no>
To: 670241@bugs.debian.org
Subject: Re: linux-2.6: Backporting the qmi_wwan driver to the Debian 3.2/wheezy kernels
Date: Wed, 25 Apr 2012 09:22:07 +0200
Bjørn Mork <bjorn@mork.no> writes:

> The second batch is just a single bugfix for the sierra
> driver, which is necessary to allow the qmi_wwan driver
> to support some Sierra Wireless devices.  This could have
> gone to stable/linux-3.2.y but I did't submit it there as
> it is mostly irrelevant without the qmi_wwan driver.

Never underestimate Greg's efficiency...  Looks like he just picked up
this for 3.0-stable and 3.3-stable, so then I assume Ben will pick it
for 3.2-longterm as well.

> 2) prevent sierra from binding to QMI/wwan interfaces
>
> 749541d USB: sierra: avoid QMI/wwan interface on MC77xx

And if he does, then please ignore this commit.  It will go through
3.2-longterm upstream instead.



Bjørn




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Mon, 04 Jun 2012 20:36:18 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bjørn Mork <bjorn@mork.no>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Mon, 04 Jun 2012 20:36:18 GMT) Full text and rfc822 format available.

Message #15 received at 670241@bugs.debian.org (full text, mbox):

From: Bjørn Mork <bjorn@mork.no>
To: 670241@bugs.debian.org
Subject: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Mon, 04 Jun 2012 22:07:44 +0200
A few changes since the bug was reported:

- v3.2.19 includes a few fixes in cdc-wdm which conflict with the
  backport.  The easiest way to merge these is to first revert them, do
  the backport, and then reapply the fixes as cherry-picks from
  mainline.

- The sierra driver fix has been included in stable and can be dropped.

- A few new device IDs has been added to the qmi_wwan driver.


The following procedure will produce a backported version of qmi_wwan
and the supporting cdc-wdm driver on top of a clean v3.2.19:


1) revert the following conflicting stable fixes (will be reapplied in
   the next step):

8fd4242 USB: cdc-wdm: cannot use dev_printk when device is gone
0c68ab1 USB: cdc-wdm: add debug messages on cleanup
7569109 USB: cdc-wdm: fix memory leak
811c72b USB: cdc-wdm: sanitize error returns


2) cherry-pick to add subdriver support to cdc-wdm:

19b85b3 USB: cdc-wdm: no need to fill the in request URB every time it's submitted
8143a89 USB: cdc-wdm: kill the now unnecessary bMaxPacketSize0 field and udev variable
820c629 USB: cdc-wdm: avoid printing odd-looking "cdc-wdm-176" names
fec67b4 usb: cdc-wdm: Add device-id for Huawei 3G/LTE modems
8804420 usb: cdc-wdm: make reset work with blocking IO
8457d99 USB: cdc-wdm: no need to use usb_alloc_coherent
0dffb48 usb: cdc-wdm: split out reusable parts of probe
b0c1386 usb: cdc-wdm: adding list lookup indirection
3cc3615 usb: cdc-wdm: adding usb_cdc_wdm_register subdriver support
24a85ba USB: cdc-wdm: sanitize error returns
2f338c8 USB: cdc-wdm: fix memory leak
880bca3 USB: cdc-wdm: add debug messages on cleanup
12a98b2 USB: cdc-wdm: cleanup error codes
6b0b79d USB: cdc-wdm: cannot use dev_printk when device is gone
6286d85 USB: cdc-wdm: remove from device list on disconnect


3) cherry-pick to add qmi_wwan driver:

423ce8c net: usb: qmi_wwan: New driver for Huawei QMI based WWAN devices
c3ecb08 net: qmi_wwan: support devices having a shared QMI/wwan interface
b086cf0 net: qmi_wwan: add Gobi and Pantech UML290 device IDs
11207b6 net: qmi_wwan: add support for ZTE MF820D
1aa35a2 USB: qmi_wwan: Add ZTE (Vodafone) K3565-Z and K4505-Z net interfaces
dbb6d09 USB: qmi_wwan: Add ZTE (Vodafone) K3570-Z and K3571-Z net interfaces
3bc17d1 net: qmi_wwan: support Sierra Wireless MC77xx devices in QMI mode
88c16dc net: qmi_wwan: Add Vodafone/Huawei K5005 support
0000188 USB: qmi_wwan: Make forced int 4 whitelist generic
8965c98 USB: qmi_wwan: Add ZTE (Vodafone) K3765-Z
f7142e6 USB: qmi_wwan: Add ZTE (Vodafone) K3520-Z
5e071b5 net: qmi_wwan: Add Sierra Wireless device IDs



The diffstat of the above is:

bjorn@nemi:/usr/local/src/git/linux$ git diff --stat v3.2.19..HEAD
 drivers/net/usb/Kconfig     |   22 +++++++
 drivers/net/usb/Makefile    |    1 +
 drivers/net/usb/qmi_wwan.c  |  581 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 drivers/usb/class/cdc-wdm.c |  345 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------------------------------------
 include/linux/usb/cdc-wdm.h |   19 ++++++
 5 files changed, 849 insertions(+), 119 deletions(-)



The resulting drivers will be identical to the 3.5-rc1 versions, with
the exception of the module_usb_driver() macro and the
disable_hub_initiated_lpm patch:


bjorn@nemi:/usr/local/src/git/linux$ git diff HEAD..v3.5-rc1 -- drivers/usb/class/cdc-wdm.c include/linux/usb/cdc-wdm.h drivers/net/usb/qmi_wwan.c
diff --git a/drivers/net/usb/qmi_wwan.c b/drivers/net/usb/qmi_wwan.c
index 32755c6..3b20678 100644
--- a/drivers/net/usb/qmi_wwan.c
+++ b/drivers/net/usb/qmi_wwan.c
@@ -562,6 +562,7 @@ static struct usb_driver qmi_wwan_driver = {
        .resume               = qmi_wwan_resume,
        .reset_resume         = qmi_wwan_resume,
        .supports_autosuspend = 1,
+       .disable_hub_initiated_lpm = 1,
 };
 
 static int __init qmi_wwan_init(void)
diff --git a/drivers/usb/class/cdc-wdm.c b/drivers/usb/class/cdc-wdm.c
index 2236fe7..ea8b304 100644
--- a/drivers/usb/class/cdc-wdm.c
+++ b/drivers/usb/class/cdc-wdm.c
@@ -1034,26 +1034,10 @@ static struct usb_driver wdm_driver = {
        .post_reset =   wdm_post_reset,
        .id_table =     wdm_ids,
        .supports_autosuspend = 1,
+       .disable_hub_initiated_lpm = 1,
 };
 
-/* --- low level module stuff --- */
-
-static int __init wdm_init(void)
-{
-       int rv;
-
-       rv = usb_register(&wdm_driver);
-
-       return rv;
-}
-
-static void __exit wdm_exit(void)
-{
-       usb_deregister(&wdm_driver);
-}
-
-module_init(wdm_init);
-module_exit(wdm_exit);
+module_usb_driver(wdm_driver);
 
 MODULE_AUTHOR(DRIVER_AUTHOR);
 MODULE_DESCRIPTION(DRIVER_DESC);




Bjørn




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Mon, 04 Jun 2012 20:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Mon, 04 Jun 2012 20:51:03 GMT) Full text and rfc822 format available.

Message #20 received at 670241@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Bjørn Mork <bjorn@mork.no>, 670241@bugs.debian.org
Subject: Re: Bug#670241: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Mon, 04 Jun 2012 21:45:55 +0100
[Message part 1 (text/plain, inline)]
On Mon, 2012-06-04 at 22:07 +0200, Bjørn Mork wrote:
> A few changes since the bug was reported:
> 
> - v3.2.19 includes a few fixes in cdc-wdm which conflict with the
>   backport.  The easiest way to merge these is to first revert them, do
>   the backport, and then reapply the fixes as cherry-picks from
>   mainline.

Having to revert is not ideal, but it's OK.

[...]
> The resulting drivers will be identical to the 3.5-rc1 versions, with
> the exception of the module_usb_driver() macro and the
> disable_hub_initiated_lpm patch:
[...]

I'm quite happy to add module_usb_driver() if it helps to make cleaner
backports.  Should be just these two:

commit 907d0ed1c84114d4e8dafd66af982515d3739c90
Author: Lars-Peter Clausen <lars@metafoo.de>
Date:   Wed Nov 16 10:13:35 2011 +0100

    drivercore: Generalize module_platform_driver

commit f3a6a4b6cfc80e57bf16bb12f9425bec1a5731a9
Author: Greg Kroah-Hartman <gregkh@suse.de>
Date:   Thu Nov 17 14:38:33 2011 -0800

    USB: Add helper macro for usb_driver boilerplate

Ben.

-- 
Ben Hutchings
It is impossible to make anything foolproof because fools are so ingenious.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Tue, 05 Jun 2012 08:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bjørn Mork <bjorn@mork.no>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 05 Jun 2012 08:12:03 GMT) Full text and rfc822 format available.

Message #25 received at 670241@bugs.debian.org (full text, mbox):

From: Bjørn Mork <bjorn@mork.no>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: 670241@bugs.debian.org
Subject: Re: Bug#670241: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Tue, 05 Jun 2012 10:10:13 +0200
Ben Hutchings <ben@decadent.org.uk> writes:
> On Mon, 2012-06-04 at 22:07 +0200, Bjørn Mork wrote:
>> A few changes since the bug was reported:
>> 
>> - v3.2.19 includes a few fixes in cdc-wdm which conflict with the
>>   backport.  The easiest way to merge these is to first revert them, do
>>   the backport, and then reapply the fixes as cherry-picks from
>>   mainline.
>
> Having to revert is not ideal, but it's OK.

The advantage is that all mainline patches apply cleanly.  I can prepare
a set without the reverts if you want that, but that would mean a number
of context adjustments in the backport.

> [...]
>> The resulting drivers will be identical to the 3.5-rc1 versions, with
>> the exception of the module_usb_driver() macro and the
>> disable_hub_initiated_lpm patch:
> [...]
>
> I'm quite happy to add module_usb_driver() if it helps to make cleaner
> backports.

I don't think it helps much.  The mainline patch applying the macro to
the drivers cannot be used anyway, as that is a bulk change touching a
large number of drivers at once.  And this part of the driver is rarely
used as context, so it doesn't affect backporting other patches.  Better
just leave it as it is.


Bjørn




Severity set to 'important' from 'wishlist' Request was from Jonathan Nieder <jrnieder@gmail.com> to control@bugs.debian.org. (Thu, 28 Jun 2012 05:33:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Tue, 17 Jul 2012 18:09:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bjørn Mork <bjorn@mork.no>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 17 Jul 2012 18:09:03 GMT) Full text and rfc822 format available.

Message #32 received at 670241@bugs.debian.org (full text, mbox):

From: Bjørn Mork <bjorn@mork.no>
To: 670241@bugs.debian.org
Subject: Re: Bug#670241: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Tue, 17 Jul 2012 20:01:24 +0200
block 670241 by 681912
thanks

Please don't implement this just yet.  The ModemManager version in
wheezy may choke on the ports provided by the new driver.  Ref
https://bugzilla.redhat.com/show_bug.cgi?id=835153

I've opened a bug against ModemManager requesting the addition of the
upstream workaround, and am now blocking this bug against it.  Better
not include the driver until we sure it won't trigger any ModemManager
regressions.

Feel free to close this bug with a wontfix if you like.  After all, the
qmi_wwan driver will never be very useful in wheezy, given that the
modemmanager package is frozen on a version too old to ever gain QMI
support.

And thanks for delaying this until Fedora sorted out the worst problems
:-)  That's wise.


Bjørn



Added blocking bug(s) of 670241: 681912 Request was from Bjørn Mork <bjorn@mork.no> to control@bugs.debian.org. (Tue, 17 Jul 2012 18:09:09 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Tue, 17 Jul 2012 19:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 17 Jul 2012 19:06:03 GMT) Full text and rfc822 format available.

Message #39 received at 670241@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Bjørn Mork <bjorn@mork.no>, 670241@bugs.debian.org
Subject: Re: Bug#670241: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Tue, 17 Jul 2012 19:37:48 +0100
On Tue, Jul 17, 2012 at 08:01:24PM +0200, Bjørn Mork wrote:
> block 670241 by 681912
> thanks
> 
> Please don't implement this just yet.  The ModemManager version in
> wheezy may choke on the ports provided by the new driver.  Ref
> https://bugzilla.redhat.com/show_bug.cgi?id=835153
> 
> I've opened a bug against ModemManager requesting the addition of the
> upstream workaround, and am now blocking this bug against it.  Better
> not include the driver until we sure it won't trigger any ModemManager
> regressions.
> 
> Feel free to close this bug with a wontfix if you like.  After all, the
> qmi_wwan driver will never be very useful in wheezy, given that the
> modemmanager package is frozen on a version too old to ever gain QMI
> support.
 
How large are the required changes to ModemManager?  New hardware
support is a perfectly good reason for a freeze exception, whichever
package it's in.

Ben.

> And thanks for delaying this until Fedora sorted out the worst problems
> :-)  That's wise.

-- 
Ben Hutchings
We get into the habit of living before acquiring the habit of thinking.
                                                              - Albert Camus



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#670241; Package linux-2.6. (Tue, 17 Jul 2012 19:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bjørn Mork <bjorn@mork.no>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. (Tue, 17 Jul 2012 19:15:03 GMT) Full text and rfc822 format available.

Message #44 received at 670241@bugs.debian.org (full text, mbox):

From: Bjørn Mork <bjorn@mork.no>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: 670241@bugs.debian.org
Subject: Re: Bug#670241: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Tue, 17 Jul 2012 21:13:59 +0200
Ben Hutchings <ben@decadent.org.uk> writes:
> On Tue, Jul 17, 2012 at 08:01:24PM +0200, Bjørn Mork wrote:
>
>> Feel free to close this bug with a wontfix if you like.  After all, the
>> qmi_wwan driver will never be very useful in wheezy, given that the
>> modemmanager package is frozen on a version too old to ever gain QMI
>> support.
>  
> How large are the required changes to ModemManager?  

Huge.

The next version (0.6) will use a completely new D-Bus API making it
incompatible with the current NetworkManager and any other ModemManager
users. Ref http://www.freedesktop.org/wiki/ModemManager06

And the QMI support might even not be ready for 0.6.  It's currently
being developed in a separate branch and not yet fully operational.

> New hardware
> support is a perfectly good reason for a freeze exception, whichever
> package it's in.

Sure, and I appreciate that.  But do note that this driver does not add
support for any new USB device.  All supported modems are composite
devices having at least one serial port supporting PPP.  This means that
the driver isn't critical for basic device support.  It only adds
support for another device function, which most users will see as
redundant.


Bjørn



Reply sent to Ben Hutchings <ben@decadent.org.uk>:
You have taken responsibility. (Tue, 17 Jul 2012 20:06:10 GMT) Full text and rfc822 format available.

Notification sent to Bjørn Mork <bjorn@mork.no>:
Bug acknowledged by developer. (Tue, 17 Jul 2012 20:06:10 GMT) Full text and rfc822 format available.

Message #49 received at 670241-done@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: 670241-done@bugs.debian.org
Subject: Re: Bug#670241: Updated qmi_wwan backport based on v3.2.19, including new device IDs from v3.5-rc1
Date: Tue, 17 Jul 2012 20:44:46 +0100
On Tue, Jul 17, 2012 at 09:13:59PM +0200, Bjørn Mork wrote:
> Ben Hutchings <ben@decadent.org.uk> writes:
[...]
> > New hardware
> > support is a perfectly good reason for a freeze exception, whichever
> > package it's in.
> 
> Sure, and I appreciate that.  But do note that this driver does not add
> support for any new USB device.  All supported modems are composite
> devices having at least one serial port supporting PPP.  This means that
> the driver isn't critical for basic device support.  It only adds
> support for another device function, which most users will see as
> redundant.
 
OK, then I'm closing this as not needed.

Ben.

-- 
Ben Hutchings
We get into the habit of living before acquiring the habit of thinking.
                                                              - Albert Camus



Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 15 Aug 2012 07:27:39 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 17 04:03:37 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.